# define to 1 if using gcc2.96 (to use only -O1), else comment it out
%define gcc296  1
# Set to 0 if you *just* built gcl, and don't want to redo it
%define dogcl   1 
%define	gclver	2.4.1
Summary:	Maxima Symbolic Computation Program	
Name:   	maxima	
Version: 	5.6	
Release:  	4	
Copyright: 	GPL
Group:   	Applications/Engineering
Url:		http://maxima.sourceforge.net/	
Source0: 	ftp.ma.utexas.edu:/pub/maxima/%{name}-%{version}.tgz
Source1: 	ftp.ma.utexas.edu:/pub/gcl/gcl-%{gclver}.tgz
Patch0:		%{name}-5.6-reloc.patch
Patch1:		%{name}-5.6-filesub.patch
Patch2:		%{name}-gcl-minvers.patch
Patch3:		%{name}-gcl-optflags.patch
Prefix:		%{_prefix}
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%(id -u -n)-root
Obsoletes:	maxima-emacs

%description
Maxima is a full symbolic computation program.  It is full featured
doing symbolic manipulation of polynomials, matrices, rational
functions, integration, Todd-coxeter, graphing, bigfloats.  It has a
symbolic debugger source level debugger for maxima code.  Maxima is
based on the original Macsyma developed at MIT in the 1970's.  It is
quite reliable, and has good garbage collection, and no memory leaks.
It comes with hundreds of self tests.  William Schelter at University
of Texas, has been responsible for development since the mid 1980's.
See http://www.ma.utexas.edu/maxima.html for more information.  He has
recently been able to get DOE to allow him to distribute Maxima under
the GPL.

%if 0
%package emacs
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
Requires:       emacs
Summary: %{name} emacs mode 
%description emacs
%{name} emacs mode 
%endif

%prep
rm -rf $RPM_BUILD_ROOT
%if %dogcl
rm -rf gcl-%{gclver}
%endif

%if %dogcl
%setup -q -b 1
%else
%setup -q
%endif

%if %dogcl
(
MAXDIR=`pwd`
GCLDIR=`echo ${MAXDIR}/../gcl-%{gclver}`
%{?gcc296:RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS | sed 's/-O./-O1/'`"; export RPM_OPT_FLAGS}

# Do patch/configure for GCL
cd $GCLDIR
%patch2 -p1 -b .minver
%patch3 -p1 -b .optflags
# Manually patchup -O4 -> $RPM_OPT_FLAGS
perl -pi -e "s:-O4:${RPM_OPT_FLAGS}:g"  o/makefile
perl -pi -e "s:-O4:${RPM_OPT_FLAGS}:g"  mp/makefile
perl -pi -e "s:RPM_OPT_FLAGS:${RPM_OPT_FLAGS}:" cmpnew/cmpmain.lsp


# do gmp ahead of time
cd gmp
CFLAGS="$RPM_OPT_FLAGS" ; export CFLAGS ; \
./configure --target=%{_target_cpu} --silent --disable-shared

cd $GCLDIR
%configure --enable-notify=no
)
%endif

%patch0 -p1 -b .reloc
%patch1 -p1 -b .filesub

%build
# Reset vars in new section
MAXDIR=`pwd`
GCLDIR=`echo ${MAXDIR}/../gcl-%{gclver}`

%if %dogcl
(
%{?gcc296:RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS | sed 's/-O./-O1/'`"; export RPM_OPT_FLAGS}
cd $GCLDIR 
make

)
%endif

# Now maxima
cat configure.in | sed \
 -e "s:GCLDIR=.*:GCLDIR=${GCLDIR}:g" \
 -e "s:^MAXDIR=.*:MAXDIR=${MAXDIR}:g" \
 -e "s:^PREFIX_DIR=.*:PREFIX_DIR=%{prefix}:g" \
 -e "s:^INFO_DIR=.*:INFO_DIR=%{_infodir}:g" \
 -e "s:^MAN_DIR=.*:MAN_DIR=%{_mandir}/man1:g" \
 -e "s:^EMACS_SITE_LISP=.*:EMACS_SITE_LISP=${EMACS_SITE_LISP}:g" > configure
chmod +x configure
 
%configure

make

%install
install -d $RPM_BUILD_ROOT{%{_infodir},%{_infodir},%{_mandir}/man1,%{_datadir}/emacs/site-lisp}
%makeinstall \
	DESTDIR=$RPM_BUILD_ROOT \
	PREFIX_DIR=$RPM_BUILD_ROOT%{prefix} \
	INFO_DIR=$RPM_BUILD_ROOT%{_infodir} \
	MAN_DIR=$RPM_BUILD_ROOT%{_mandir}/man1 \
	EMACS_SITE_LISP=$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp

# Fixup maxima, xmaxima wrappers
perl -pi -e"s,MAXIMA_DIRECTORY=.*,MAXIMA_DIRECTORY=%{_libdir}/%{name}-%{version}," \
        $RPM_BUILD_ROOT%{_bindir}/maxima
perl -pi -e"s,MAXIMA_DIRECTORY=.*,MAXIMA_DIRECTORY=%{_libdir}/%{name}-%{version}," \
        $RPM_BUILD_ROOT%{_bindir}/xmaxima

# Remove extraneous info stuff
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir
rm -rf $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/info

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc COPYING COPYING1 intro.html README README.binary 
%doc info/*.html
%{_bindir}/*
%{_infodir}/*
%{_libdir}/*
%{_mandir}/man?/*
%if 0
%files emacs
%defattr(-,root,root)
%endif
%{_datadir}/emacs/site-lisp/*

%changelog 
* Thu Apr 04 2002 Rex Dieter <rdieter@unl.edu> 5.6-4
- nix emacs subpkg

* Wed Apr 03 2002 Rex Dieter <rdieter@unl.edu> 5.6-3
- rebuild against gcl-2.4.1 (but stick with -O1, for now)
- new Url

* Fri Dec 07 2001 Rex Dieter <rdieter@unl.edu> 5.6-2
- experiment with -O1 optimization
  (I think -O2 yields a bad gcl compiler)

* Thu Dec 06 2001 Rex Dieter <rdieter@unl.edu> 5.6-1
- emacs subpkg
- specfile cleanup

* Wed Nov 21 2001 Rex Dieter <rdieter@unl.edu>
- first try, 5.6
- gcl currently only builds ok on redhat6 
  (redhat7 configure broken)
